<!--
Thanks for wanting to report an issue you've found. Please delete
this text and fill in the template below. If unsure about something, just do as
best as you're able.

Note that it will be much easier for us to fix the issue if a test case that
reproduces the problem is provided. Ideally this test case should not have any
external dependencies. We understand that it is not always possible to reduce
your code to a small test case, but we would appreciate to have as much data as
possible. Thank you!
-->

### Prerequisites
<!--
You do not have to reinstall Firefox or disable all addons. You can just create a new profile that only has ClearURLs installed and where no settings are changed. Instructions can be found here: https://support.mozilla.org/en-US/kb/profile-manager-create-and-remove-firefox-profiles
-->
* [ ] Can you reproduce the problem in a **fresh** firefox profile with **only** ClearURLs?
* [ ] Are you running the latest version of ClearURLs?
* [ ] Are you have changed settings under `about:config`?

### Description

[Description of the bug or feature]

### Steps to Reproduce

1. [First Step]
2. [Second Step]
3. [and so on...]

**Expected behavior:** [What you expected to happen]

**Actual behavior:** [What actually happened]

### System
* **Version**: [compulsory. you must provide your version]
* **Platform**: [either `uname -a` output, or if Windows, version and 32-bit or
  64-bit]
* **Country**: [The country from which you called the page. You can found your country here: http://ip-api.com/json/?fields=country]

### Log
<!-- Please enable the log functionality of ClearURLs and copy your log into this table. -->
<!-- Or if the log is to long, save the html file (press ctrl+s) and attach to this issue the `Log from ClearURLs.html` file -->

| Before processing | After processing | Rule | Time |
|-------------------|------------------|------|------|
|                   |                  |      |      |

<!-- If you attach the html file, please copy into the ``` area -->
```





```
